import { usePolling } from "../hook/api";

export default function useLeaderboardApi(leaderboardReducer, config) {
    const [leaderboard, dispatchLeaderboard] = leaderboardReducer;

    const usePollingTable = () => {
        const onSuccess = (table) => {
            dispatchLeaderboard({ type: 'next', table });
        }

        const isPollingTable = usePolling('/api/leaderboard', onSuccess, config.intervalMode(300));
        if (leaderboard.isPollingTable !== isPollingTable) {
            dispatchLeaderboard({ type: 'next', isPollingTable });
        }

        return leaderboard;
    }

    return {
        pollTable: usePollingTable
    }
}