import './Leaderboard.css';
import React from "react"
import Loading from '../components/Loading';

export default function Leaderboard({ players }) {

  const table = players.leaderboard.table;
  if (table == null)
    return <Loading />

  const tableRows = Object.keys(table).map(playerName => {
    var rank = table[playerName];

    return <tr key={playerName} className={players.isCurrentUser(playerName) && 'currentuser'}>
      <td>{playerName}</td>
      <td>{rank.total}</td>
      <td>{rank.victory}</td>
      <td>{rank.draw}</td>
    </tr>
  });

  return (
    <div className="Leaderboard">
      <table>
        <thead>
          <tr>
            <th></th>
            <th>Total</th>
            <th>Victory</th>
            <th>Draw</th>
          </tr>
        </thead>
        <tbody>
          {tableRows}
        </tbody>
      </table>
    </div>
  )
};