import React, { useContext, /* useEffect,*/ useRef, useState } from 'react';
import { useLocation, matchPath } from 'react-router-dom';
import { GamesContext } from '../../context/games';
//import { useLocationChange } from '../../hook/Location';

export default function Message2Opponent({ dispatchGames }) {
  const games = useContext(GamesContext);
  const [message2opponent, setMessage2opponent] = useState('');
  const { pathname } = useLocation();
  const timeoutIdRef = useRef(null);

  if (timeoutIdRef.current === null) {
    // sync: internal <- external
    // Sync external and internsl states only in abnsence of a delay timer
    console.log("check message", message2opponent);
    if (matchPath('/games/new', pathname)) {
      if (message2opponent !== games.newGame.message2opponent)
        setMessage2opponent(games.newGame.message2opponent);
    } 
    else
      if (message2opponent !== '') {
        setMessage2opponent('');
      }
  }

  console.log('timeout.current', timeoutIdRef.current)
  /* --- */


  const delayedSync = (message2opponent) => {
    timeoutIdRef.current = null;

    // sync: internl -> external
    if (matchPath('/games/new', pathname))
      return dispatchGames({ type: 'nextNewGame', message2opponent });

    console.warn('unknown path');
  }

  const onChange = (value) => {
    setMessage2opponent(value);

    if (timeoutIdRef.current)
      clearTimeout(timeoutIdRef.current); // cancel previous sync

    timeoutIdRef.current = setTimeout(() => delayedSync(value), 500);
  }


  //var gpathname;
  //useLocationChange(({ pathname }) => {


  return (
    <input className='Message2Opponent'
      placeholder='Message to opponent'
      value={message2opponent}
      maxLength={150}
      onChange={e => onChange(e.target.value)}
    />
  )
}